package DSRG.MW;

import java.util.Vector;

public class DeepVector extends Vector implements Cloneable {
    
    public DeepVector() {
        super();
    }

    public  DeepVector(int capacity) {
        super(capacity);
    }

    public synchronized Object clone() {
        // copy traditionally
        DeepVector dv = (DeepVector)super.clone();
        // iterate through the elements
        for (int i = 0 ; i < elementCount ; i++ ) {
            // if you found a DeepVector
            if (elementData[i] instanceof DeepVector) {
                // call DeepVector-clone recursively
                dv.elementData[i]=((DeepVector)elementData[i]).clone();
            }
        }
        return dv;
    }
}

