package algebraTree;
import java.util.*;

import DSRG.MW.*;


/** Objects of this class represent updates for a SchemaSQL
 *  wrapper. SchemaSQL updates include data updates as well as schema
 *  updates. Data updates can be add-tuple, delete-tuple, or
 *  update-tuple (with arbitrary changes in the data). A data update
 *  is represented by a "before-after" pair. If "before" is empty, we
 *  have an add, if "after" is empty, we have a delete, if both are
 *  not-null, we have an update. Schema changes are
 *  {add|del|ren}-{att|rel} such that the attribute/relation must be
 *  identified and the type of update too.
 *  These two updates classes are two subclasses of this one.
*/
public  abstract class Update {
    /** the table name which this update concerns. Must be valid */
    public String relation;
}    
