package algebraTree;
import java.util.Random;

/** provides helper functions for the algebraTree class */
public class Util {
    
    // prefix must be all caps!!!
    private static final String prefix = "SCHEMASQL_TMP_";
    private static  int start = 3141;


    public Util() {
        exit("Util class can't be instantiated");
    }
    
    /* returns a new random table name */
    static public String getTempTableName() {
        return prefix + java.lang.Integer.toString(start++);
    }

    /* returns a new random attribute name */
    static public String getTempAttributeName() {
        return prefix + java.lang.Integer.toString(start++);
    }

    /** prints the stack trace and exits */
    static public void exit(String message) {
        class UserExitException extends Exception {
            public UserExitException() {super();}
            public UserExitException(String s) {super(s);}
        }
        try {
            System.err.println("=====================================");
            System.err.println("              ERROR                  ");
            System.err.println("=====================================");
            System.err.println(message);
            System.err.println("=====================================");
            throw new UserExitException();
        }
        catch (UserExitException e) {
            e.printStackTrace();
            
        }
        System.exit(0);
    }

    static public void invalidView() {
        System.out.println("=====================================");
        System.out.println("View has become invalid");
        System.out.println("=====================================");
        System.exit(0);
    }

}
