//
// Generated by JTB 1.2.1
//

package schemaSQLParser.visitor;
import schemaSQLParser.syntaxtree.*;
import java.util.*;

/**
 * All Object visitors must implement this interface.
 */
public interface ObjectVisitor {
   //
   // Object Auto class visitors
   //
   public Object visit(NodeList n, Object argu);
   public Object visit(NodeListOptional n, Object argu);
   public Object visit(NodeOptional n, Object argu);
   public Object visit(NodeSequence n, Object argu);
   public Object visit(NodeToken n, Object argu);

   //
   // User-generated visitor methods below
   //

   /**
    * nodeChoice -> ProcedureDeclaration()
    *       | FunctionDeclaration()
    *       | SequenceOfStatements()
    */
   public Object visit(CompilationUnit n, Object argu);

   /**
    * nodeToken -> "DECLARE"
    * declarations -> Declarations()
    */
   public Object visit(DeclarationSection n, Object argu);

   /**
    * nodeList -> ( ( IdentifierDeclaration() | CursorDeclaration() | PragmaDeclaration() ) ";" )+
    * nodeListOptional -> ( ProcedureDeclaration() | FunctionDeclaration() )*
    */
   public Object visit(Declarations n, Object argu);

   /**
    * nodeToken -> <S_IDENTIFIER>
    * nodeChoice -> ( ConstantDeclaration() | VariableDeclaration() | ExceptionDeclaration() )
    */
   public Object visit(IdentifierDeclaration n, Object argu);

   /**
    * nodeToken -> "CURSOR"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeOptional -> [ "(" ParameterList() ")" ]
    * nodeToken2 -> "IS"
    * selectStatement -> SelectStatement()
    */
   public Object visit(CursorDeclaration n, Object argu);

   /**
    * nodeToken -> "PROCEDURE"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeOptional -> [ "(" ParameterList() ")" ]
    * nodeChoice -> ( ";" | "IS" ProcedureBody() )
    */
   public Object visit(ProcedureDeclaration n, Object argu);

   /**
    * nodeOptional -> [ Declarations() ]
    * beginEndBlock -> BeginEndBlock()
    */
   public Object visit(ProcedureBody n, Object argu);

   /**
    * nodeToken -> "FUNCTION"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeOptional -> [ "(" ParameterList() ")" ]
    * nodeToken2 -> "RETURN"
    * typeDeclaration -> TypeDeclaration()
    * nodeChoice -> ( ";" | "IS" FunctionBody() )
    */
   public Object visit(FunctionDeclaration n, Object argu);

   /**
    * nodeOptional -> [ Declarations() ]
    * beginEndBlock -> BeginEndBlock()
    */
   public Object visit(FunctionBody n, Object argu);

   /**
    * nodeToken -> "PRAGMA"
    * nodeToken1 -> "EXCEPTION_INIT"
    * nodeToken2 -> "("
    * numOrID -> NumOrID()
    * nodeToken3 -> ","
    * numOrID1 -> NumOrID()
    * nodeToken4 -> ")"
    */
   public Object visit(PragmaDeclaration n, Object argu);

   /**
    * typeDeclaration -> TypeDeclaration()
    * nodeOptional -> [ "NOT" "NULL" ]
    * nodeOptional1 -> [ ( ":=" | "DEFAULT" ) PlSqlExpression() ]
    */
   public Object visit(VariableDeclaration n, Object argu);

   /**
    * nodeToken -> "CONSTANT"
    * typeDeclaration -> TypeDeclaration()
    * nodeOptional -> [ "NOT" "NULL" ]
    * nodeChoice -> ( ":=" | "DEFAULT" )
    * plSqlExpression -> PlSqlExpression()
    */
   public Object visit(ConstantDeclaration n, Object argu);

   /**
    * nodeChoice -> BasicDataTypeDeclaration()
    *       | ( <S_IDENTIFIER> ( "%TYPE" | "%ROWTYPE" ) )
    *       | TableColumn() "%TYPE"
    *       | <S_IDENTIFIER>
    */
   public Object visit(TypeDeclaration n, Object argu);

   /**
    * nodeChoice -> ( "CHAR" | "VARCHAR" | "VARCHAR2" | "INTEGER" | "NUMBER" | "NATURAL" | "REAL" | "FLOAT" ) [ "(" <S_NUMBER> [ "," <S_NUMBER> ] ")" ]
    *       | "DATE"
    *       | "BINARY_INTEGER"
    *       | "BOOLEAN"
    */
   public Object visit(BasicDataTypeDeclaration n, Object argu);

   /**
    * nodeToken -> "EXCEPTION"
    */
   public Object visit(ExceptionDeclaration n, Object argu);

   /**
    * nodeToken -> "BEGIN"
    * sequenceOfStatements -> SequenceOfStatements()
    * nodeOptional -> [ ExceptionBlock() ]
    * nodeToken1 -> "END"
    * nodeOptional1 -> [ <S_IDENTIFIER> ]
    * nodeToken2 -> ";"
    */
   public Object visit(BeginEndBlock n, Object argu);

   /**
    * nodeList -> ( PLSQLStatement() )+
    */
   public Object visit(SequenceOfStatements n, Object argu);

   /**
    * nodeToken -> "EXCEPTION"
    * nodeList -> ( ExceptionHandler() )+
    */
   public Object visit(ExceptionBlock n, Object argu);

   /**
    * nodeToken -> "WHEN"
    * nodeChoice -> ( <S_IDENTIFIER> ( "OR" <S_IDENTIFIER> )* | "OTHERS" )
    * nodeToken1 -> "THEN"
    * sequenceOfStatements -> SequenceOfStatements()
    */
   public Object visit(ExceptionHandler n, Object argu);

   /**
    * nodeChoice -> SubroutineCall()
    *       | AssignmentStatement()
    *       | ExitStatement()
    *       | GotoStatement()
    *       | IfStatement()
    *       | LoopStatement()
    *       | NullStatement()
    *       | RaiseStatement()
    *       | ReturnStatement()
    *       | SQLStatement()
    *       | LabelDeclaration()
    *       | [ DeclarationSection() ] BeginEndBlock()
    */
   public Object visit(PLSQLStatement n, Object argu);

   /**
    * nodeToken -> "<<"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> ">>"
    */
   public Object visit(LabelDeclaration n, Object argu);

   /**
    * nodeChoice -> CloseStatement()
    *       | CommitStatement()
    *       | DeleteStatement()
    *       | FetchStatement()
    *       | InsertStatement()
    *       | LockTableStatement()
    *       | OpenStatement()
    *       | RollbackStatement()
    *       | SavepointStatement()
    *       | QueryStatement()
    *       | SetTransactionStatement()
    *       | UpdateStatement()
    */
   public Object visit(SQLStatement n, Object argu);

   /**
    * nodeToken -> <S_IDENTIFIER>
    * nodeOptional -> [ "." <S_IDENTIFIER> ]
    * nodeOptional1 -> [ "(" Arguments() ")" ]
    * nodeToken1 -> ";"
    */
   public Object visit(SubroutineCall n, Object argu);

   /**
    * nodeChoice -> ( ( <S_IDENTIFIER> [ "." <S_IDENTIFIER> ] ":=" PlSqlExpression() ) | ( <S_BIND> ":=" PlSqlExpression() ) )
    * nodeToken -> ";"
    */
   public Object visit(AssignmentStatement n, Object argu);

   /**
    * nodeToken -> "EXIT"
    * nodeOptional -> [ <S_IDENTIFIER> ]
    * nodeOptional1 -> [ "WHEN" PlSqlExpression() ]
    * nodeToken1 -> ";"
    */
   public Object visit(ExitStatement n, Object argu);

   /**
    * nodeToken -> "GOTO"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> ";"
    */
   public Object visit(GotoStatement n, Object argu);

   /**
    * nodeToken -> "IF"
    * plSqlExpression -> PlSqlExpression()
    * nodeToken1 -> "THEN"
    * sequenceOfStatements -> SequenceOfStatements()
    * nodeListOptional -> ( "ELSIF" PlSqlExpression() "THEN" SequenceOfStatements() )*
    * nodeOptional -> [ "ELSE" SequenceOfStatements() ]
    * nodeToken2 -> "END"
    * nodeToken3 -> "IF"
    * nodeOptional1 -> [ <S_IDENTIFIER> ]
    * nodeToken4 -> ";"
    */
   public Object visit(IfStatement n, Object argu);

   /**
    * nodeChoice -> NormalLoop()
    *       | WhileLoop()
    *       | ForLoop()
    */
   public Object visit(LoopStatement n, Object argu);

   /**
    * nodeToken -> "LOOP"
    * sequenceOfStatements -> SequenceOfStatements()
    * nodeToken1 -> "END"
    * nodeToken2 -> "LOOP"
    * nodeOptional -> [ <S_IDENTIFIER> ]
    * nodeToken3 -> ";"
    */
   public Object visit(NormalLoop n, Object argu);

   /**
    * nodeToken -> "WHILE"
    * plSqlExpression -> PlSqlExpression()
    * normalLoop -> NormalLoop()
    */
   public Object visit(WhileLoop n, Object argu);

   /**
    * nodeChoice -> NumericForLoop()
    *       | CursorForLoop()
    */
   public Object visit(ForLoop n, Object argu);

   /**
    * nodeToken -> "FOR"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> "IN"
    * nodeOptional -> [ "REVERSE" ]
    * plSqlSimpleExpression -> PlSqlSimpleExpression()
    * nodeToken3 -> ".."
    */
   public Object visit(NumericForLoopLookahead n, Object argu);

   /**
    * nodeToken -> "FOR"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> "IN"
    * nodeOptional -> [ "REVERSE" ]
    * plSqlSimpleExpression -> PlSqlSimpleExpression()
    * nodeToken3 -> ".."
    * plSqlSimpleExpression1 -> PlSqlSimpleExpression()
    * normalLoop -> NormalLoop()
    */
   public Object visit(NumericForLoop n, Object argu);

   /**
    * nodeToken -> "FOR"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> "IN"
    * nodeChoice -> ( <S_IDENTIFIER> [ "(" Arguments() ")" ] | "(" SelectStatement() ")" )
    * normalLoop -> NormalLoop()
    */
   public Object visit(CursorForLoop n, Object argu);

   /**
    * nodeToken -> "NULL"
    * nodeToken1 -> ";"
    */
   public Object visit(NullStatement n, Object argu);

   /**
    * nodeToken -> "RAISE"
    * nodeOptional -> [ <S_IDENTIFIER> ]
    * nodeToken1 -> ";"
    */
   public Object visit(RaiseStatement n, Object argu);

   /**
    * nodeToken -> "RETURN"
    * nodeOptional -> [ PlSqlExpression() ]
    * nodeToken1 -> ";"
    */
   public Object visit(ReturnStatement n, Object argu);

   /**
    * nodeToken -> "CLOSE"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> ";"
    */
   public Object visit(CloseStatement n, Object argu);

   /**
    * nodeToken -> "COMMIT"
    * nodeOptional -> [ "WORK" ]
    * nodeOptional1 -> [ "COMMENT" <S_CHAR_LITERAL> ]
    * nodeToken1 -> ";"
    */
   public Object visit(CommitStatement n, Object argu);

   /**
    * nodeToken -> "FETCH"
    * nodeSequence -> ( <S_IDENTIFIER> )
    * nodeToken1 -> "INTO"
    * nodeChoice -> ( <S_IDENTIFIER> | <S_BIND> )
    * nodeListOptional -> ( "," ( <S_IDENTIFIER> | <S_BIND> ) )*
    * nodeToken2 -> ";"
    */
   public Object visit(FetchStatement n, Object argu);

   /**
    * nodeToken -> "LOCK"
    * nodeToken1 -> "TABLE"
    * tableReference -> TableReference()
    * nodeListOptional -> ( "," TableReference() )*
    * nodeToken2 -> "IN"
    * lockMode -> LockMode()
    * nodeToken3 -> "MODE"
    * nodeOptional -> [ "NOWAIT" ]
    * nodeToken4 -> ";"
    */
   public Object visit(LockTableStatement n, Object argu);

   /**
    * nodeToken -> "OPEN"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeOptional -> [ "(" Arguments() ")" ]
    * nodeToken2 -> ";"
    */
   public Object visit(OpenStatement n, Object argu);

   /**
    * nodeToken -> "ROLLBACK"
    * nodeOptional -> [ "WORK" ]
    * nodeOptional1 -> [ "TO" [ "SAVEPOINT" ] <S_IDENTIFIER> ]
    * nodeOptional2 -> [ "COMMENT" <S_CHAR_LITERAL> ]
    * nodeToken1 -> ";"
    */
   public Object visit(RollbackStatement n, Object argu);

   /**
    * nodeToken -> "SET"
    * nodeToken1 -> "TRANSACTION"
    * nodeChoice -> ( ( "READ" ( "ONLY" | "WRITE" ) ) | ( "USE" "ROLLBACK" "SEGMENT" <S_IDENTIFIER> ) )
    * nodeToken2 -> ";"
    */
   public Object visit(SetTransactionStatement n, Object argu);

   /**
    * nodeChoice -> ( "ROW" ( "SHARE" | "EXCLUSIVE" ) )
    *       | ( "SHARE" [ "UPDATE" | ( "ROW" "EXCLUSIVE" ) ] )
    *       | ( "EXCLUSIVE" )
    */
   public Object visit(LockMode n, Object argu);

   /**
    * nodeToken -> "SAVEPOINT"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> ";"
    */
   public Object visit(SavepointStatement n, Object argu);

   /**
    * nodeToken -> "UPDATE"
    * tableReference -> TableReference()
    * nodeOptional -> [ <S_IDENTIFIER> ]
    * nodeToken1 -> "SET"
    * columnValues -> ColumnValues()
    * nodeOptional1 -> [ "WHERE" ( SQLExpression() | "CURRENT" "OF" <S_IDENTIFIER> ) ]
    * nodeToken2 -> ";"
    */
   public Object visit(UpdateStatement n, Object argu);

   /**
    * tableColumn -> TableColumn()
    * nodeToken -> "="
    * updatedValue -> UpdatedValue()
    * nodeListOptional -> ( "," TableColumn() "=" UpdatedValue() )*
    */
   public Object visit(ColumnValues n, Object argu);

   /**
    * nodeChoice -> "(" SelectStatement() ")"
    *       | PlSqlExpression()
    */
   public Object visit(UpdatedValue n, Object argu);

   /**
    * nodeToken -> "INSERT"
    * nodeToken1 -> "INTO"
    * tableReference -> TableReference()
    * nodeOptional -> [ "(" TableColumn() ( "," TableColumn() )* ")" ]
    * nodeChoice -> ( "VALUES" "(" PlSqlExpressionList() ")" | SelectStatement() )
    * nodeToken2 -> ";"
    */
   public Object visit(InsertStatement n, Object argu);

   /**
    * nodeToken -> "DELETE"
    * nodeOptional -> [ "FROM" ]
    * tableReference -> TableReference()
    * nodeOptional1 -> [ <S_IDENTIFIER> ]
    * nodeOptional2 -> [ "WHERE" ( SQLExpression() | "CURRENT" "OF" <S_IDENTIFIER> ) ]
    * nodeToken1 -> ";"
    */
   public Object visit(DeleteStatement n, Object argu);

   /**
    * nodeOptional -> [ CreateViewClause() ]
    * selectStatement -> SelectStatement()
    * nodeToken -> ";"
    */
   public Object visit(QueryStatement n, Object argu);

   /**
    * nodeToken -> "CREATE"
    * nodeToken1 -> "VIEW"
    * viewReference -> ViewReference()
    * createViewList -> CreateViewList()
    * nodeToken2 -> "AS"
    */
   public Object visit(CreateViewClause n, Object argu);

   /**
    * plSqlAndExpression -> PlSqlAndExpression()
    * nodeListOptional -> ( "OR" PlSqlAndExpression() )*
    */
   public Object visit(PlSqlExpression n, Object argu);

   /**
    * plSqlUnaryLogicalExpression -> PlSqlUnaryLogicalExpression()
    * nodeListOptional -> ( "AND" PlSqlUnaryLogicalExpression() )*
    */
   public Object visit(PlSqlAndExpression n, Object argu);

   /**
    * nodeOptional -> [ "NOT" ]
    * plSqlRelationalExpression -> PlSqlRelationalExpression()
    */
   public Object visit(PlSqlUnaryLogicalExpression n, Object argu);

   /**
    * plSqlSimpleExpression -> PlSqlSimpleExpression()
    * nodeOptional -> ( Relop() PlSqlSimpleExpression() | PlSqlInClause() | PlSqlBetweenClause() | PlSqlLikeClause() | IsNullClause() )?
    */
   public Object visit(PlSqlRelationalExpression n, Object argu);

   /**
    * plSqlExpression -> PlSqlExpression()
    * nodeListOptional -> ( "," PlSqlExpression() )*
    */
   public Object visit(PlSqlExpressionList n, Object argu);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "IN"
    * nodeToken1 -> "("
    * plSqlExpressionList -> PlSqlExpressionList()
    * nodeToken2 -> ")"
    */
   public Object visit(PlSqlInClause n, Object argu);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "BETWEEN"
    * plSqlSimpleExpression -> PlSqlSimpleExpression()
    * nodeToken1 -> "AND"
    * plSqlSimpleExpression1 -> PlSqlSimpleExpression()
    */
   public Object visit(PlSqlBetweenClause n, Object argu);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "LIKE"
    * plSqlSimpleExpression -> PlSqlSimpleExpression()
    */
   public Object visit(PlSqlLikeClause n, Object argu);

   /**
    * nodeToken -> "IS"
    * nodeOptional -> [ "NOT" ]
    * nodeToken1 -> "NULL"
    */
   public Object visit(IsNullClause n, Object argu);

   /**
    * plSqlMultiplicativeExpression -> PlSqlMultiplicativeExpression()
    * nodeListOptional -> ( ( "+" | "-" | "||" ) PlSqlMultiplicativeExpression() )*
    */
   public Object visit(PlSqlSimpleExpression n, Object argu);

   /**
    * plSqlExpotentExpression -> PlSqlExpotentExpression()
    * nodeListOptional -> ( ( "*" | "/" ) PlSqlExpotentExpression() )*
    */
   public Object visit(PlSqlMultiplicativeExpression n, Object argu);

   /**
    * plSqlUnaryExpression -> PlSqlUnaryExpression()
    * nodeListOptional -> ( "**" PlSqlUnaryExpression() )*
    */
   public Object visit(PlSqlExpotentExpression n, Object argu);

   /**
    * nodeChoice -> ( ( "+" | "-" ) PlSqlPrimaryExpression() )
    *       | PlSqlPrimaryExpression()
    */
   public Object visit(PlSqlUnaryExpression n, Object argu);

   /**
    * nodeChoice -> "NULL"
    *       | ( <S_IDENTIFIER> ( "%FOUND" | "%NOTFOUND" | "%ISOPEN" | "%ROWCOUNT" ) )
    *       | ( <S_IDENTIFIER> "(" Arguments() ")" )
    *       | ( <S_IDENTIFIER> [ "." <S_IDENTIFIER> ] )
    *       | ( "SQL" ( "%FOUND" | "%NOTFOUND" | "%ISOPEN" | "%ROWCOUNT" ) )
    *       | <S_NUMBER>
    *       | <S_CHAR_LITERAL>
    *       | <S_BIND>
    *       | "(" PlSqlExpression() ")"
    */
   public Object visit(PlSqlPrimaryExpression n, Object argu);

   /**
    * oracleObjectName -> OracleObjectName()
    * nodeOptional -> [ "." OracleObjectName() ]
    */
   public Object visit(TableColumn n, Object argu);

   /**
    * nodeChoice -> <S_QUOTED_IDENTIFIER>
    *       | <S_IDENTIFIER>
    */
   public Object visit(OracleObjectName n, Object argu);

   /**
    * nodeChoice -> "="
    *       | "!="
    *       | "#"
    *       | "<>"
    *       | ">"
    *       | ">="
    *       | "<"
    *       | "<="
    */
   public Object visit(Relop n, Object argu);

   /**
    * oracleObjectName -> OracleObjectName()
    * nodeOptional -> [ "." OracleObjectName() ]
    */
   public Object visit(TableReference n, Object argu);

   /**
    * oracleObjectName -> OracleObjectName()
    */
   public Object visit(ViewReference n, Object argu);

   /**
    * parameter -> Parameter()
    * nodeListOptional -> ( "," Parameter() )*
    */
   public Object visit(ParameterList n, Object argu);

   /**
    * nodeChoice -> <S_IDENTIFIER>
    *       | ( [ "+" | "-" ] <S_NUMBER> )
    */
   public Object visit(NumOrID n, Object argu);

   /**
    * nodeToken -> <S_IDENTIFIER>
    * nodeOptional -> [ [ "IN" ] [ "OUT" ] TypeDeclaration() [ ( ":=" | "DEFAULT" ) PlSqlExpression() ] ]
    */
   public Object visit(Parameter n, Object argu);

   /**
    * plSqlExpressionList -> PlSqlExpressionList()
    */
   public Object visit(Arguments n, Object argu);

   /**
    * selectWithoutOrder -> SelectWithoutOrder()
    * nodeOptional -> [ OrderByClause() ]
    * nodeOptional1 -> [ ForUpdateClause() ]
    */
   public Object visit(SelectStatement n, Object argu);

   /**
    * nodeToken -> "SELECT"
    * nodeOptional -> [ "ALL" | "DISTINCT" ]
    * selectList -> SelectList()
    * nodeOptional1 -> [ IntoClause() ]
    * fromClause -> FromClause()
    * nodeOptional2 -> [ WhereClause() ]
    * nodeOptional3 -> [ ConnectClause() ]
    * nodeOptional4 -> [ GroupByClause() ]
    * nodeOptional5 -> [ SetClause() ]
    */
   public Object visit(SelectWithoutOrder n, Object argu);

   /**
    * nodeChoice -> "*"
    *       | SelectItem() ( "," SelectItem() )*
    */
   public Object visit(SelectList n, Object argu);

   /**
    * nodeChoice -> OracleObjectName() ".*"
    *       | OracleObjectName() "." OracleObjectName() ".*"
    *       | SQLSimpleExpression() [ ColumnAlias() ]
    */
   public Object visit(SelectItem n, Object argu);

   /**
    * nodeToken -> <S_IDENTIFIER>
    */
   public Object visit(ColumnAlias n, Object argu);

   /**
    * nodeToken -> "("
    * createViewItem -> CreateViewItem()
    * nodeListOptional -> ( "," CreateViewItem() )*
    * nodeToken1 -> ")"
    */
   public Object visit(CreateViewList n, Object argu);

   /**
    * oracleObjectName -> OracleObjectName()
    */
   public Object visit(CreateViewItem n, Object argu);

   /**
    * nodeToken -> "INTO"
    * intoItem -> IntoItem()
    * nodeListOptional -> ( "," IntoItem() )*
    */
   public Object visit(IntoClause n, Object argu);

   /**
    * nodeChoice -> ( <S_IDENTIFIER> [ "." <S_IDENTIFIER> ] )
    *       | ( <S_BIND> )
    */
   public Object visit(IntoItem n, Object argu);

   /**
    * nodeToken -> "FROM"
    * schemaSQLFromItem -> SchemaSQLFromItem()
    * nodeListOptional -> ( "," SchemaSQLFromItem() )*
    */
   public Object visit(FromClause n, Object argu);

   /**
    * nodeChoice -> SchemaSQL_RelationNames()
    *       | SchemaSQL_AttributeNames()
    *       | FromItem()
    */
   public Object visit(SchemaSQLFromItem n, Object argu);

   /**
    * tableReference -> TableReference()
    * nodeOptional -> [ TableAlias() ]
    */
   public Object visit(FromItem n, Object argu);

   /**
    * nodeToken -> <O_ARROW>
    * tableAlias -> TableAlias()
    */
   public Object visit(SchemaSQL_RelationNames n, Object argu);

   /**
    * tableReference -> TableReference()
    * nodeToken -> <O_ARROW>
    * columnAlias -> ColumnAlias()
    */
   public Object visit(SchemaSQL_AttributeNames n, Object argu);

   /**
    * nodeToken -> <S_IDENTIFIER>
    */
   public Object visit(TableAlias n, Object argu);

   /**
    * nodeToken -> "WHERE"
    * sQLExpression -> SQLExpression()
    */
   public Object visit(WhereClause n, Object argu);

   /**
    * nodeSequence -> ( [ "START" "WITH" SQLExpression() ] "CONNECT" "BY" SQLExpression() [ "START" "WITH" SQLExpression() ] )
    */
   public Object visit(ConnectClause n, Object argu);

   /**
    * nodeToken -> "GROUP"
    * nodeToken1 -> "BY"
    * sQLExpressionList -> SQLExpressionList()
    * nodeOptional -> [ "HAVING" SQLExpression() ]
    */
   public Object visit(GroupByClause n, Object argu);

   /**
    * nodeChoice -> ( ( "UNION" [ "ALL" ] ) | "INTERSECT" | "MINUS" )
    * nodeChoice1 -> ( ( "(" SelectWithoutOrder() ")" ) | SelectWithoutOrder() )
    */
   public Object visit(SetClause n, Object argu);

   /**
    * nodeToken -> "ORDER"
    * nodeToken1 -> "BY"
    * sQLSimpleExpression -> SQLSimpleExpression()
    * nodeOptional -> [ "ASC" | "DESC" ]
    * nodeListOptional -> ( "," SQLSimpleExpression() [ "ASC" | "DESC" ] )*
    */
   public Object visit(OrderByClause n, Object argu);

   /**
    * nodeToken -> "FOR"
    * nodeToken1 -> "UPDATE"
    * nodeToken2 -> "OF"
    * tableColumn -> TableColumn()
    * nodeListOptional -> ( "," TableColumn() )*
    */
   public Object visit(ForUpdateClause n, Object argu);

   /**
    * sQLAndExpression -> SQLAndExpression()
    * nodeListOptional -> ( "OR" SQLAndExpression() )*
    */
   public Object visit(SQLExpression n, Object argu);

   /**
    * sQLUnaryLogicalExpression -> SQLUnaryLogicalExpression()
    * nodeListOptional -> ( "AND" SQLUnaryLogicalExpression() )*
    */
   public Object visit(SQLAndExpression n, Object argu);

   /**
    * nodeChoice -> ExistsClause()
    *       | ( [ "NOT" ] SQLRelationalExpression() )
    */
   public Object visit(SQLUnaryLogicalExpression n, Object argu);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "EXISTS"
    * nodeToken1 -> "("
    * subQuery -> SubQuery()
    * nodeToken2 -> ")"
    */
   public Object visit(ExistsClause n, Object argu);

   /**
    * nodeChoice -> ( "(" SQLExpressionList() ")" | ( [ "PRIOR" ] SQLSimpleExpression() ) )
    * nodeOptional -> ( SQLRelationalOperatorExpression() | ( SQLInClause() ) | ( SQLBetweenClause() ) | ( SQLLikeClause() ) | IsNullClause() )?
    */
   public Object visit(SQLRelationalExpression n, Object argu);

   /**
    * sQLSimpleExpression -> SQLSimpleExpression()
    * nodeListOptional -> ( "," SQLSimpleExpression() )*
    */
   public Object visit(SQLExpressionList n, Object argu);

   /**
    * relop -> Relop()
    * nodeChoice -> ( ( [ "ALL" | "ANY" ] "(" SubQuery() ")" ) | [ "PRIOR" ] SQLSimpleExpression() )
    */
   public Object visit(SQLRelationalOperatorExpression n, Object argu);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "IN"
    * nodeToken1 -> "("
    * nodeChoice -> ( SQLExpressionList() | SubQuery() )
    * nodeToken2 -> ")"
    */
   public Object visit(SQLInClause n, Object argu);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "BETWEEN"
    * sQLSimpleExpression -> SQLSimpleExpression()
    * nodeToken1 -> "AND"
    * sQLSimpleExpression1 -> SQLSimpleExpression()
    */
   public Object visit(SQLBetweenClause n, Object argu);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "LIKE"
    * sQLSimpleExpression -> SQLSimpleExpression()
    */
   public Object visit(SQLLikeClause n, Object argu);

   /**
    * sQLMultiplicativeExpression -> SQLMultiplicativeExpression()
    * nodeListOptional -> ( ( "+" | "-" | "||" ) SQLMultiplicativeExpression() )*
    */
   public Object visit(SQLSimpleExpression n, Object argu);

   /**
    * sQLExpotentExpression -> SQLExpotentExpression()
    * nodeListOptional -> ( ( "*" | "/" ) SQLExpotentExpression() )*
    */
   public Object visit(SQLMultiplicativeExpression n, Object argu);

   /**
    * sQLUnaryExpression -> SQLUnaryExpression()
    * nodeListOptional -> ( "**" SQLUnaryExpression() )*
    */
   public Object visit(SQLExpotentExpression n, Object argu);

   /**
    * nodeOptional -> [ "+" | "-" ]
    * sQLPrimaryExpression -> SQLPrimaryExpression()
    */
   public Object visit(SQLUnaryExpression n, Object argu);

   /**
    * nodeChoice -> "NULL"
    *       | FunctionCall()
    *       | OuterJoinExpression()
    *       | TableColumn()
    *       | <S_NUMBER>
    *       | <S_CHAR_LITERAL>
    *       | <S_BIND>
    *       | "(" SQLExpression() ")"
    */
   public Object visit(SQLPrimaryExpression n, Object argu);

   /**
    * oracleObjectName -> OracleObjectName()
    * nodeOptional -> [ "." OracleObjectName() [ "." OracleObjectName() ] ]
    * nodeToken -> "("
    * nodeOptional1 -> [ [ "DISTINCT" | "ALL" ] ( SQLArguments() | "*" ) ]
    * nodeToken1 -> ")"
    */
   public Object visit(FunctionCall n, Object argu);

   /**
    * sQLExpressionList -> SQLExpressionList()
    */
   public Object visit(SQLArguments n, Object argu);

   /**
    * oracleObjectName -> OracleObjectName()
    * nodeOptional -> [ "." OracleObjectName() [ "." OracleObjectName() ] ]
    * nodeToken -> "("
    * nodeToken1 -> "+"
    * nodeToken2 -> ")"
    */
   public Object visit(OuterJoinExpression n, Object argu);

   /**
    * selectWithoutOrder -> SelectWithoutOrder()
    */
   public Object visit(SubQuery n, Object argu);

}
