//
// Generated by JTB 1.2.1
//

package schemaSQLParser.visitor;
import schemaSQLParser.syntaxtree.*;
import java.util.*;

/**
 * All void visitors must implement this interface.
 */
public interface Visitor {
   //
   // void Auto class visitors
   //
   public void visit(NodeList n);
   public void visit(NodeListOptional n);
   public void visit(NodeOptional n);
   public void visit(NodeSequence n);
   public void visit(NodeToken n);

   //
   // User-generated visitor methods below
   //

   /**
    * nodeChoice -> ProcedureDeclaration()
    *       | FunctionDeclaration()
    *       | SequenceOfStatements()
    */
   public void visit(CompilationUnit n);

   /**
    * nodeToken -> "DECLARE"
    * declarations -> Declarations()
    */
   public void visit(DeclarationSection n);

   /**
    * nodeList -> ( ( IdentifierDeclaration() | CursorDeclaration() | PragmaDeclaration() ) ";" )+
    * nodeListOptional -> ( ProcedureDeclaration() | FunctionDeclaration() )*
    */
   public void visit(Declarations n);

   /**
    * nodeToken -> <S_IDENTIFIER>
    * nodeChoice -> ( ConstantDeclaration() | VariableDeclaration() | ExceptionDeclaration() )
    */
   public void visit(IdentifierDeclaration n);

   /**
    * nodeToken -> "CURSOR"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeOptional -> [ "(" ParameterList() ")" ]
    * nodeToken2 -> "IS"
    * selectStatement -> SelectStatement()
    */
   public void visit(CursorDeclaration n);

   /**
    * nodeToken -> "PROCEDURE"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeOptional -> [ "(" ParameterList() ")" ]
    * nodeChoice -> ( ";" | "IS" ProcedureBody() )
    */
   public void visit(ProcedureDeclaration n);

   /**
    * nodeOptional -> [ Declarations() ]
    * beginEndBlock -> BeginEndBlock()
    */
   public void visit(ProcedureBody n);

   /**
    * nodeToken -> "FUNCTION"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeOptional -> [ "(" ParameterList() ")" ]
    * nodeToken2 -> "RETURN"
    * typeDeclaration -> TypeDeclaration()
    * nodeChoice -> ( ";" | "IS" FunctionBody() )
    */
   public void visit(FunctionDeclaration n);

   /**
    * nodeOptional -> [ Declarations() ]
    * beginEndBlock -> BeginEndBlock()
    */
   public void visit(FunctionBody n);

   /**
    * nodeToken -> "PRAGMA"
    * nodeToken1 -> "EXCEPTION_INIT"
    * nodeToken2 -> "("
    * numOrID -> NumOrID()
    * nodeToken3 -> ","
    * numOrID1 -> NumOrID()
    * nodeToken4 -> ")"
    */
   public void visit(PragmaDeclaration n);

   /**
    * typeDeclaration -> TypeDeclaration()
    * nodeOptional -> [ "NOT" "NULL" ]
    * nodeOptional1 -> [ ( ":=" | "DEFAULT" ) PlSqlExpression() ]
    */
   public void visit(VariableDeclaration n);

   /**
    * nodeToken -> "CONSTANT"
    * typeDeclaration -> TypeDeclaration()
    * nodeOptional -> [ "NOT" "NULL" ]
    * nodeChoice -> ( ":=" | "DEFAULT" )
    * plSqlExpression -> PlSqlExpression()
    */
   public void visit(ConstantDeclaration n);

   /**
    * nodeChoice -> BasicDataTypeDeclaration()
    *       | ( <S_IDENTIFIER> ( "%TYPE" | "%ROWTYPE" ) )
    *       | TableColumn() "%TYPE"
    *       | <S_IDENTIFIER>
    */
   public void visit(TypeDeclaration n);

   /**
    * nodeChoice -> ( "CHAR" | "VARCHAR" | "VARCHAR2" | "INTEGER" | "NUMBER" | "NATURAL" | "REAL" | "FLOAT" ) [ "(" <S_NUMBER> [ "," <S_NUMBER> ] ")" ]
    *       | "DATE"
    *       | "BINARY_INTEGER"
    *       | "BOOLEAN"
    */
   public void visit(BasicDataTypeDeclaration n);

   /**
    * nodeToken -> "EXCEPTION"
    */
   public void visit(ExceptionDeclaration n);

   /**
    * nodeToken -> "BEGIN"
    * sequenceOfStatements -> SequenceOfStatements()
    * nodeOptional -> [ ExceptionBlock() ]
    * nodeToken1 -> "END"
    * nodeOptional1 -> [ <S_IDENTIFIER> ]
    * nodeToken2 -> ";"
    */
   public void visit(BeginEndBlock n);

   /**
    * nodeList -> ( PLSQLStatement() )+
    */
   public void visit(SequenceOfStatements n);

   /**
    * nodeToken -> "EXCEPTION"
    * nodeList -> ( ExceptionHandler() )+
    */
   public void visit(ExceptionBlock n);

   /**
    * nodeToken -> "WHEN"
    * nodeChoice -> ( <S_IDENTIFIER> ( "OR" <S_IDENTIFIER> )* | "OTHERS" )
    * nodeToken1 -> "THEN"
    * sequenceOfStatements -> SequenceOfStatements()
    */
   public void visit(ExceptionHandler n);

   /**
    * nodeChoice -> SubroutineCall()
    *       | AssignmentStatement()
    *       | ExitStatement()
    *       | GotoStatement()
    *       | IfStatement()
    *       | LoopStatement()
    *       | NullStatement()
    *       | RaiseStatement()
    *       | ReturnStatement()
    *       | SQLStatement()
    *       | LabelDeclaration()
    *       | [ DeclarationSection() ] BeginEndBlock()
    */
   public void visit(PLSQLStatement n);

   /**
    * nodeToken -> "<<"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> ">>"
    */
   public void visit(LabelDeclaration n);

   /**
    * nodeChoice -> CloseStatement()
    *       | CommitStatement()
    *       | DeleteStatement()
    *       | FetchStatement()
    *       | InsertStatement()
    *       | LockTableStatement()
    *       | OpenStatement()
    *       | RollbackStatement()
    *       | SavepointStatement()
    *       | QueryStatement()
    *       | SetTransactionStatement()
    *       | UpdateStatement()
    */
   public void visit(SQLStatement n);

   /**
    * nodeToken -> <S_IDENTIFIER>
    * nodeOptional -> [ "." <S_IDENTIFIER> ]
    * nodeOptional1 -> [ "(" Arguments() ")" ]
    * nodeToken1 -> ";"
    */
   public void visit(SubroutineCall n);

   /**
    * nodeChoice -> ( ( <S_IDENTIFIER> [ "." <S_IDENTIFIER> ] ":=" PlSqlExpression() ) | ( <S_BIND> ":=" PlSqlExpression() ) )
    * nodeToken -> ";"
    */
   public void visit(AssignmentStatement n);

   /**
    * nodeToken -> "EXIT"
    * nodeOptional -> [ <S_IDENTIFIER> ]
    * nodeOptional1 -> [ "WHEN" PlSqlExpression() ]
    * nodeToken1 -> ";"
    */
   public void visit(ExitStatement n);

   /**
    * nodeToken -> "GOTO"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> ";"
    */
   public void visit(GotoStatement n);

   /**
    * nodeToken -> "IF"
    * plSqlExpression -> PlSqlExpression()
    * nodeToken1 -> "THEN"
    * sequenceOfStatements -> SequenceOfStatements()
    * nodeListOptional -> ( "ELSIF" PlSqlExpression() "THEN" SequenceOfStatements() )*
    * nodeOptional -> [ "ELSE" SequenceOfStatements() ]
    * nodeToken2 -> "END"
    * nodeToken3 -> "IF"
    * nodeOptional1 -> [ <S_IDENTIFIER> ]
    * nodeToken4 -> ";"
    */
   public void visit(IfStatement n);

   /**
    * nodeChoice -> NormalLoop()
    *       | WhileLoop()
    *       | ForLoop()
    */
   public void visit(LoopStatement n);

   /**
    * nodeToken -> "LOOP"
    * sequenceOfStatements -> SequenceOfStatements()
    * nodeToken1 -> "END"
    * nodeToken2 -> "LOOP"
    * nodeOptional -> [ <S_IDENTIFIER> ]
    * nodeToken3 -> ";"
    */
   public void visit(NormalLoop n);

   /**
    * nodeToken -> "WHILE"
    * plSqlExpression -> PlSqlExpression()
    * normalLoop -> NormalLoop()
    */
   public void visit(WhileLoop n);

   /**
    * nodeChoice -> NumericForLoop()
    *       | CursorForLoop()
    */
   public void visit(ForLoop n);

   /**
    * nodeToken -> "FOR"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> "IN"
    * nodeOptional -> [ "REVERSE" ]
    * plSqlSimpleExpression -> PlSqlSimpleExpression()
    * nodeToken3 -> ".."
    */
   public void visit(NumericForLoopLookahead n);

   /**
    * nodeToken -> "FOR"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> "IN"
    * nodeOptional -> [ "REVERSE" ]
    * plSqlSimpleExpression -> PlSqlSimpleExpression()
    * nodeToken3 -> ".."
    * plSqlSimpleExpression1 -> PlSqlSimpleExpression()
    * normalLoop -> NormalLoop()
    */
   public void visit(NumericForLoop n);

   /**
    * nodeToken -> "FOR"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> "IN"
    * nodeChoice -> ( <S_IDENTIFIER> [ "(" Arguments() ")" ] | "(" SelectStatement() ")" )
    * normalLoop -> NormalLoop()
    */
   public void visit(CursorForLoop n);

   /**
    * nodeToken -> "NULL"
    * nodeToken1 -> ";"
    */
   public void visit(NullStatement n);

   /**
    * nodeToken -> "RAISE"
    * nodeOptional -> [ <S_IDENTIFIER> ]
    * nodeToken1 -> ";"
    */
   public void visit(RaiseStatement n);

   /**
    * nodeToken -> "RETURN"
    * nodeOptional -> [ PlSqlExpression() ]
    * nodeToken1 -> ";"
    */
   public void visit(ReturnStatement n);

   /**
    * nodeToken -> "CLOSE"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> ";"
    */
   public void visit(CloseStatement n);

   /**
    * nodeToken -> "COMMIT"
    * nodeOptional -> [ "WORK" ]
    * nodeOptional1 -> [ "COMMENT" <S_CHAR_LITERAL> ]
    * nodeToken1 -> ";"
    */
   public void visit(CommitStatement n);

   /**
    * nodeToken -> "FETCH"
    * nodeSequence -> ( <S_IDENTIFIER> )
    * nodeToken1 -> "INTO"
    * nodeChoice -> ( <S_IDENTIFIER> | <S_BIND> )
    * nodeListOptional -> ( "," ( <S_IDENTIFIER> | <S_BIND> ) )*
    * nodeToken2 -> ";"
    */
   public void visit(FetchStatement n);

   /**
    * nodeToken -> "LOCK"
    * nodeToken1 -> "TABLE"
    * tableReference -> TableReference()
    * nodeListOptional -> ( "," TableReference() )*
    * nodeToken2 -> "IN"
    * lockMode -> LockMode()
    * nodeToken3 -> "MODE"
    * nodeOptional -> [ "NOWAIT" ]
    * nodeToken4 -> ";"
    */
   public void visit(LockTableStatement n);

   /**
    * nodeToken -> "OPEN"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeOptional -> [ "(" Arguments() ")" ]
    * nodeToken2 -> ";"
    */
   public void visit(OpenStatement n);

   /**
    * nodeToken -> "ROLLBACK"
    * nodeOptional -> [ "WORK" ]
    * nodeOptional1 -> [ "TO" [ "SAVEPOINT" ] <S_IDENTIFIER> ]
    * nodeOptional2 -> [ "COMMENT" <S_CHAR_LITERAL> ]
    * nodeToken1 -> ";"
    */
   public void visit(RollbackStatement n);

   /**
    * nodeToken -> "SET"
    * nodeToken1 -> "TRANSACTION"
    * nodeChoice -> ( ( "READ" ( "ONLY" | "WRITE" ) ) | ( "USE" "ROLLBACK" "SEGMENT" <S_IDENTIFIER> ) )
    * nodeToken2 -> ";"
    */
   public void visit(SetTransactionStatement n);

   /**
    * nodeChoice -> ( "ROW" ( "SHARE" | "EXCLUSIVE" ) )
    *       | ( "SHARE" [ "UPDATE" | ( "ROW" "EXCLUSIVE" ) ] )
    *       | ( "EXCLUSIVE" )
    */
   public void visit(LockMode n);

   /**
    * nodeToken -> "SAVEPOINT"
    * nodeToken1 -> <S_IDENTIFIER>
    * nodeToken2 -> ";"
    */
   public void visit(SavepointStatement n);

   /**
    * nodeToken -> "UPDATE"
    * tableReference -> TableReference()
    * nodeOptional -> [ <S_IDENTIFIER> ]
    * nodeToken1 -> "SET"
    * columnValues -> ColumnValues()
    * nodeOptional1 -> [ "WHERE" ( SQLExpression() | "CURRENT" "OF" <S_IDENTIFIER> ) ]
    * nodeToken2 -> ";"
    */
   public void visit(UpdateStatement n);

   /**
    * tableColumn -> TableColumn()
    * nodeToken -> "="
    * updatedValue -> UpdatedValue()
    * nodeListOptional -> ( "," TableColumn() "=" UpdatedValue() )*
    */
   public void visit(ColumnValues n);

   /**
    * nodeChoice -> "(" SelectStatement() ")"
    *       | PlSqlExpression()
    */
   public void visit(UpdatedValue n);

   /**
    * nodeToken -> "INSERT"
    * nodeToken1 -> "INTO"
    * tableReference -> TableReference()
    * nodeOptional -> [ "(" TableColumn() ( "," TableColumn() )* ")" ]
    * nodeChoice -> ( "VALUES" "(" PlSqlExpressionList() ")" | SelectStatement() )
    * nodeToken2 -> ";"
    */
   public void visit(InsertStatement n);

   /**
    * nodeToken -> "DELETE"
    * nodeOptional -> [ "FROM" ]
    * tableReference -> TableReference()
    * nodeOptional1 -> [ <S_IDENTIFIER> ]
    * nodeOptional2 -> [ "WHERE" ( SQLExpression() | "CURRENT" "OF" <S_IDENTIFIER> ) ]
    * nodeToken1 -> ";"
    */
   public void visit(DeleteStatement n);

   /**
    * nodeOptional -> [ CreateViewClause() ]
    * selectStatement -> SelectStatement()
    * nodeToken -> ";"
    */
   public void visit(QueryStatement n);

   /**
    * nodeToken -> "CREATE"
    * nodeToken1 -> "VIEW"
    * viewReference -> ViewReference()
    * createViewList -> CreateViewList()
    * nodeToken2 -> "AS"
    */
   public void visit(CreateViewClause n);

   /**
    * plSqlAndExpression -> PlSqlAndExpression()
    * nodeListOptional -> ( "OR" PlSqlAndExpression() )*
    */
   public void visit(PlSqlExpression n);

   /**
    * plSqlUnaryLogicalExpression -> PlSqlUnaryLogicalExpression()
    * nodeListOptional -> ( "AND" PlSqlUnaryLogicalExpression() )*
    */
   public void visit(PlSqlAndExpression n);

   /**
    * nodeOptional -> [ "NOT" ]
    * plSqlRelationalExpression -> PlSqlRelationalExpression()
    */
   public void visit(PlSqlUnaryLogicalExpression n);

   /**
    * plSqlSimpleExpression -> PlSqlSimpleExpression()
    * nodeOptional -> ( Relop() PlSqlSimpleExpression() | PlSqlInClause() | PlSqlBetweenClause() | PlSqlLikeClause() | IsNullClause() )?
    */
   public void visit(PlSqlRelationalExpression n);

   /**
    * plSqlExpression -> PlSqlExpression()
    * nodeListOptional -> ( "," PlSqlExpression() )*
    */
   public void visit(PlSqlExpressionList n);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "IN"
    * nodeToken1 -> "("
    * plSqlExpressionList -> PlSqlExpressionList()
    * nodeToken2 -> ")"
    */
   public void visit(PlSqlInClause n);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "BETWEEN"
    * plSqlSimpleExpression -> PlSqlSimpleExpression()
    * nodeToken1 -> "AND"
    * plSqlSimpleExpression1 -> PlSqlSimpleExpression()
    */
   public void visit(PlSqlBetweenClause n);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "LIKE"
    * plSqlSimpleExpression -> PlSqlSimpleExpression()
    */
   public void visit(PlSqlLikeClause n);

   /**
    * nodeToken -> "IS"
    * nodeOptional -> [ "NOT" ]
    * nodeToken1 -> "NULL"
    */
   public void visit(IsNullClause n);

   /**
    * plSqlMultiplicativeExpression -> PlSqlMultiplicativeExpression()
    * nodeListOptional -> ( ( "+" | "-" | "||" ) PlSqlMultiplicativeExpression() )*
    */
   public void visit(PlSqlSimpleExpression n);

   /**
    * plSqlExpotentExpression -> PlSqlExpotentExpression()
    * nodeListOptional -> ( ( "*" | "/" ) PlSqlExpotentExpression() )*
    */
   public void visit(PlSqlMultiplicativeExpression n);

   /**
    * plSqlUnaryExpression -> PlSqlUnaryExpression()
    * nodeListOptional -> ( "**" PlSqlUnaryExpression() )*
    */
   public void visit(PlSqlExpotentExpression n);

   /**
    * nodeChoice -> ( ( "+" | "-" ) PlSqlPrimaryExpression() )
    *       | PlSqlPrimaryExpression()
    */
   public void visit(PlSqlUnaryExpression n);

   /**
    * nodeChoice -> "NULL"
    *       | ( <S_IDENTIFIER> ( "%FOUND" | "%NOTFOUND" | "%ISOPEN" | "%ROWCOUNT" ) )
    *       | ( <S_IDENTIFIER> "(" Arguments() ")" )
    *       | ( <S_IDENTIFIER> [ "." <S_IDENTIFIER> ] )
    *       | ( "SQL" ( "%FOUND" | "%NOTFOUND" | "%ISOPEN" | "%ROWCOUNT" ) )
    *       | <S_NUMBER>
    *       | <S_CHAR_LITERAL>
    *       | <S_BIND>
    *       | "(" PlSqlExpression() ")"
    */
   public void visit(PlSqlPrimaryExpression n);

   /**
    * oracleObjectName -> OracleObjectName()
    * nodeOptional -> [ "." OracleObjectName() ]
    */
   public void visit(TableColumn n);

   /**
    * nodeChoice -> <S_QUOTED_IDENTIFIER>
    *       | <S_IDENTIFIER>
    */
   public void visit(OracleObjectName n);

   /**
    * nodeChoice -> "="
    *       | "!="
    *       | "#"
    *       | "<>"
    *       | ">"
    *       | ">="
    *       | "<"
    *       | "<="
    */
   public void visit(Relop n);

   /**
    * oracleObjectName -> OracleObjectName()
    * nodeOptional -> [ "." OracleObjectName() ]
    */
   public void visit(TableReference n);

   /**
    * oracleObjectName -> OracleObjectName()
    */
   public void visit(ViewReference n);

   /**
    * parameter -> Parameter()
    * nodeListOptional -> ( "," Parameter() )*
    */
   public void visit(ParameterList n);

   /**
    * nodeChoice -> <S_IDENTIFIER>
    *       | ( [ "+" | "-" ] <S_NUMBER> )
    */
   public void visit(NumOrID n);

   /**
    * nodeToken -> <S_IDENTIFIER>
    * nodeOptional -> [ [ "IN" ] [ "OUT" ] TypeDeclaration() [ ( ":=" | "DEFAULT" ) PlSqlExpression() ] ]
    */
   public void visit(Parameter n);

   /**
    * plSqlExpressionList -> PlSqlExpressionList()
    */
   public void visit(Arguments n);

   /**
    * selectWithoutOrder -> SelectWithoutOrder()
    * nodeOptional -> [ OrderByClause() ]
    * nodeOptional1 -> [ ForUpdateClause() ]
    */
   public void visit(SelectStatement n);

   /**
    * nodeToken -> "SELECT"
    * nodeOptional -> [ "ALL" | "DISTINCT" ]
    * selectList -> SelectList()
    * nodeOptional1 -> [ IntoClause() ]
    * fromClause -> FromClause()
    * nodeOptional2 -> [ WhereClause() ]
    * nodeOptional3 -> [ ConnectClause() ]
    * nodeOptional4 -> [ GroupByClause() ]
    * nodeOptional5 -> [ SetClause() ]
    */
   public void visit(SelectWithoutOrder n);

   /**
    * nodeChoice -> "*"
    *       | SelectItem() ( "," SelectItem() )*
    */
   public void visit(SelectList n);

   /**
    * nodeChoice -> OracleObjectName() ".*"
    *       | OracleObjectName() "." OracleObjectName() ".*"
    *       | SQLSimpleExpression() [ ColumnAlias() ]
    */
   public void visit(SelectItem n);

   /**
    * nodeToken -> <S_IDENTIFIER>
    */
   public void visit(ColumnAlias n);

   /**
    * nodeToken -> "("
    * createViewItem -> CreateViewItem()
    * nodeListOptional -> ( "," CreateViewItem() )*
    * nodeToken1 -> ")"
    */
   public void visit(CreateViewList n);

   /**
    * oracleObjectName -> OracleObjectName()
    */
   public void visit(CreateViewItem n);

   /**
    * nodeToken -> "INTO"
    * intoItem -> IntoItem()
    * nodeListOptional -> ( "," IntoItem() )*
    */
   public void visit(IntoClause n);

   /**
    * nodeChoice -> ( <S_IDENTIFIER> [ "." <S_IDENTIFIER> ] )
    *       | ( <S_BIND> )
    */
   public void visit(IntoItem n);

   /**
    * nodeToken -> "FROM"
    * schemaSQLFromItem -> SchemaSQLFromItem()
    * nodeListOptional -> ( "," SchemaSQLFromItem() )*
    */
   public void visit(FromClause n);

   /**
    * nodeChoice -> SchemaSQL_RelationNames()
    *       | SchemaSQL_AttributeNames()
    *       | FromItem()
    */
   public void visit(SchemaSQLFromItem n);

   /**
    * tableReference -> TableReference()
    * nodeOptional -> [ TableAlias() ]
    */
   public void visit(FromItem n);

   /**
    * nodeToken -> <O_ARROW>
    * tableAlias -> TableAlias()
    */
   public void visit(SchemaSQL_RelationNames n);

   /**
    * tableReference -> TableReference()
    * nodeToken -> <O_ARROW>
    * columnAlias -> ColumnAlias()
    */
   public void visit(SchemaSQL_AttributeNames n);

   /**
    * nodeToken -> <S_IDENTIFIER>
    */
   public void visit(TableAlias n);

   /**
    * nodeToken -> "WHERE"
    * sQLExpression -> SQLExpression()
    */
   public void visit(WhereClause n);

   /**
    * nodeSequence -> ( [ "START" "WITH" SQLExpression() ] "CONNECT" "BY" SQLExpression() [ "START" "WITH" SQLExpression() ] )
    */
   public void visit(ConnectClause n);

   /**
    * nodeToken -> "GROUP"
    * nodeToken1 -> "BY"
    * sQLExpressionList -> SQLExpressionList()
    * nodeOptional -> [ "HAVING" SQLExpression() ]
    */
   public void visit(GroupByClause n);

   /**
    * nodeChoice -> ( ( "UNION" [ "ALL" ] ) | "INTERSECT" | "MINUS" )
    * nodeChoice1 -> ( ( "(" SelectWithoutOrder() ")" ) | SelectWithoutOrder() )
    */
   public void visit(SetClause n);

   /**
    * nodeToken -> "ORDER"
    * nodeToken1 -> "BY"
    * sQLSimpleExpression -> SQLSimpleExpression()
    * nodeOptional -> [ "ASC" | "DESC" ]
    * nodeListOptional -> ( "," SQLSimpleExpression() [ "ASC" | "DESC" ] )*
    */
   public void visit(OrderByClause n);

   /**
    * nodeToken -> "FOR"
    * nodeToken1 -> "UPDATE"
    * nodeToken2 -> "OF"
    * tableColumn -> TableColumn()
    * nodeListOptional -> ( "," TableColumn() )*
    */
   public void visit(ForUpdateClause n);

   /**
    * sQLAndExpression -> SQLAndExpression()
    * nodeListOptional -> ( "OR" SQLAndExpression() )*
    */
   public void visit(SQLExpression n);

   /**
    * sQLUnaryLogicalExpression -> SQLUnaryLogicalExpression()
    * nodeListOptional -> ( "AND" SQLUnaryLogicalExpression() )*
    */
   public void visit(SQLAndExpression n);

   /**
    * nodeChoice -> ExistsClause()
    *       | ( [ "NOT" ] SQLRelationalExpression() )
    */
   public void visit(SQLUnaryLogicalExpression n);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "EXISTS"
    * nodeToken1 -> "("
    * subQuery -> SubQuery()
    * nodeToken2 -> ")"
    */
   public void visit(ExistsClause n);

   /**
    * nodeChoice -> ( "(" SQLExpressionList() ")" | ( [ "PRIOR" ] SQLSimpleExpression() ) )
    * nodeOptional -> ( SQLRelationalOperatorExpression() | ( SQLInClause() ) | ( SQLBetweenClause() ) | ( SQLLikeClause() ) | IsNullClause() )?
    */
   public void visit(SQLRelationalExpression n);

   /**
    * sQLSimpleExpression -> SQLSimpleExpression()
    * nodeListOptional -> ( "," SQLSimpleExpression() )*
    */
   public void visit(SQLExpressionList n);

   /**
    * relop -> Relop()
    * nodeChoice -> ( ( [ "ALL" | "ANY" ] "(" SubQuery() ")" ) | [ "PRIOR" ] SQLSimpleExpression() )
    */
   public void visit(SQLRelationalOperatorExpression n);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "IN"
    * nodeToken1 -> "("
    * nodeChoice -> ( SQLExpressionList() | SubQuery() )
    * nodeToken2 -> ")"
    */
   public void visit(SQLInClause n);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "BETWEEN"
    * sQLSimpleExpression -> SQLSimpleExpression()
    * nodeToken1 -> "AND"
    * sQLSimpleExpression1 -> SQLSimpleExpression()
    */
   public void visit(SQLBetweenClause n);

   /**
    * nodeOptional -> [ "NOT" ]
    * nodeToken -> "LIKE"
    * sQLSimpleExpression -> SQLSimpleExpression()
    */
   public void visit(SQLLikeClause n);

   /**
    * sQLMultiplicativeExpression -> SQLMultiplicativeExpression()
    * nodeListOptional -> ( ( "+" | "-" | "||" ) SQLMultiplicativeExpression() )*
    */
   public void visit(SQLSimpleExpression n);

   /**
    * sQLExpotentExpression -> SQLExpotentExpression()
    * nodeListOptional -> ( ( "*" | "/" ) SQLExpotentExpression() )*
    */
   public void visit(SQLMultiplicativeExpression n);

   /**
    * sQLUnaryExpression -> SQLUnaryExpression()
    * nodeListOptional -> ( "**" SQLUnaryExpression() )*
    */
   public void visit(SQLExpotentExpression n);

   /**
    * nodeOptional -> [ "+" | "-" ]
    * sQLPrimaryExpression -> SQLPrimaryExpression()
    */
   public void visit(SQLUnaryExpression n);

   /**
    * nodeChoice -> "NULL"
    *       | FunctionCall()
    *       | OuterJoinExpression()
    *       | TableColumn()
    *       | <S_NUMBER>
    *       | <S_CHAR_LITERAL>
    *       | <S_BIND>
    *       | "(" SQLExpression() ")"
    */
   public void visit(SQLPrimaryExpression n);

   /**
    * oracleObjectName -> OracleObjectName()
    * nodeOptional -> [ "." OracleObjectName() [ "." OracleObjectName() ] ]
    * nodeToken -> "("
    * nodeOptional1 -> [ [ "DISTINCT" | "ALL" ] ( SQLArguments() | "*" ) ]
    * nodeToken1 -> ")"
    */
   public void visit(FunctionCall n);

   /**
    * sQLExpressionList -> SQLExpressionList()
    */
   public void visit(SQLArguments n);

   /**
    * oracleObjectName -> OracleObjectName()
    * nodeOptional -> [ "." OracleObjectName() [ "." OracleObjectName() ] ]
    * nodeToken -> "("
    * nodeToken1 -> "+"
    * nodeToken2 -> ")"
    */
   public void visit(OuterJoinExpression n);

   /**
    * selectWithoutOrder -> SelectWithoutOrder()
    */
   public void visit(SubQuery n);

}

