package treeBuilder;

/** a constraint of the form tbItem <RELOP> tbItem or tbItem LIKE tbItem */
public class tbConstraint {
    // Operators
    public static final int EQ = 0;
    public static final int NE = 1;
    public static final int LG = 2;
    public static final int GT = 3;
    public static final int GE = 4;
    public static final int LT = 5;
    public static final int LE = 6;
    public static final int LIKE=7;
    public static final int NOTLIKE=8;
    public static final int ERROR = -1;
        
    // Types
    public static final int LOCAL=0;
    public static final int JOIN=1;

    public tbItem left;
    public int operator;
    public tbItem right;
    public int type=ERROR;

    final static String[] opNames = new String[9];

    public tbConstraint() {
        opNames[0]="=";
        opNames[1]="!=";
        opNames[2]="<>";
        opNames[3]=">";
        opNames[4]=">=";
        opNames[5]="<";
        opNames[6]="<=";
        opNames[7]=" LIKE "; // spaces are important!
        opNames[8]=" NOT LIKE "; // spaces are important!
    }


    public String getOperator() {
        return opNames[operator];
    }


    /** we define that two tbConstraints are equal if their
        toString-representations are equal. Should be okay for this
        purpose. */
    public boolean equals(tbConstraint other) {
        return toString().equals(other.toString());
    }

    /** function is complicated to prevent infinite loops with the
        toString-function of "tbFromItem" */
    public String toString() {
        String result = (type==0?"LOCAL":"JOIN")+"-constraint{";

        if (left instanceof tbFromItem) {
            tbFromItem l = (tbFromItem)left;
            result += Builder.typeNames[l.type]+":  " +l.name;
            result += " as " +l.alias;
            
        }
        else
            result += left.toString();
        
        result += " "+ opNames[operator] + " ";
        
        if (right instanceof tbFromItem) {
            tbFromItem r = (tbFromItem)right;
            result += Builder.typeNames[r.type]+":  " +r.name;
            result += " as " +r.alias;
            
        }
        else
            result += right.toString();
        
        
        result += "}";
        return result;
    }

}
